-- sql/objects-drop.sql
--
-- Remove object types and things like that.
--
-- Ian Baker <ibaker@arsdigita.com>
-- $Id: objects-drop.sql,v 1.1 2002/07/09 17:35:10 rmello Exp $
--

-- This needs to go through each type and delete all the objects
-- before removing the type, using the correct procedures and all,
-- instead of these crazy hacks...

delete from acs_permissions where object_id in (
	(select object_id from acs_objects where object_type in (
		'portal', 'portal_template', 'portal_element_config','portal_datasource', 'portal_element'
	))
);

delete from acs_permissions where object_id in (
	(select package_id from apm_packages where package_key = 'portal')
);

delete from acs_objects where object_type in (
	'portal', 'portal_template', 'portal_element_config','portal_datasource', 'portal_element'
);

begin
	acs_object_type.drop_type('portal');
	acs_object_type.drop_type('portal_template');
	acs_object_type.drop_type('portal_element_config');
	acs_object_type.drop_type('portal_datasource');
	acs_object_type.drop_type('portal_element');
end;
/
show errors
