<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="check_existence_and_perms">      
      <querytext>
      select
           1 as element_exists_p,
           controlling_portal_id,
           decode(acs_permission.permission_p(:element_id, :user_id, 'read'), 't', 1, 'f', 0) as element_write_p
         from portal_elements
         where element_id = :element_id
      </querytext>
</fullquery>

 
<fullquery name="insert_element">      
      <querytext>
      declare
               eid portal_elements.element_id%TYPE;
             begin
               eid := portal_element.new (
                 element_id => :element_id,
                 name => :name,
                 description => :description,
                 exportable_p => :exportable_p,
                 datasource_id => :datasource_id,
                 template_id => :template_id,
                 controlling_portal_id => :default_portal_id
               );
             end;
      </querytext>
</fullquery>

 
<fullquery name="make_element_available">      
      <querytext>
      begin
           portal_element.make_available( element_id => :element_id, portal_id => :default_portal_id );
         end;
      </querytext>
</fullquery>

 
</queryset>
