# www/admin/element-ae-2.tcl

ad_page_contract {
    Create/edit elements.

    @author Ian Baker (ibaker@arsdigita.com)
    @creation-date 12/14/2000
    @cvs-id $Id: element-ae-2.tcl,v 1.1 2002/07/09 17:35:10 rmello Exp $
} {
    element_id:naturalnum,notnull
    name:notnull
    {description ""}
    {exportable_p:notnull "f"}
    datasource_id:naturalnum,notnull
    template_id:naturalnum,notnull
}

set user_id [ad_conn user_id]
set default_portal_id [portal_info default_portal_id]

db_transaction {

    # does that element exist?
    db_0or1row check_existence_and_perms \
	"select
           1 as element_exists_p,
           controlling_portal_id,
           decode(acs_permission.permission_p(:element_id, :user_id, 'read'), 't', 1, 'f', 0) as element_write_p
         from portal_elements
         where element_id = :element_id"
    
    if { [info exists element_exists_p] } {
	if { ! [info exists element_write_p] } {
	    ad_return_complaint "You don't have permission to edit that element."
	    return
	}

	# check if this can be done here.
	if { $controlling_portal_id != $default_portal_id } {
	    ad_return_complaint "The element you're attempting to edit is maintained within a different portal."
	    return
	}
	
	db_dml update_element \
	    "update portal_elements set
               name = :name,
               description = :description,
               exportable_p = :exportable_p,
               datasource_id = :datasource_id,
               template_id = :template_id
             where
               element_id = :element_id"
    } else {
	db_exec_plsql insert_element \
	    "declare
               eid portal_elements.element_id%TYPE;
             begin
               eid := portal_element.new (
                 element_id => :element_id,
                 name => :name,
                 description => :description,
                 exportable_p => :exportable_p,
                 datasource_id => :datasource_id,
                 template_id => :template_id,
                 controlling_portal_id => :default_portal_id
               );
             end;"
    }

    # put it in the available map.
    db_exec_plsql make_element_available \
	"begin
           portal_element.make_available( element_id => :element_id, portal_id => :default_portal_id );
         end;"

}

ns_returnredirect "index.tcl"
