# www/admin/element-ae.tcl

ad_page_contract {
    Create/edit elements.

    @author Ian Baker (ibaker@arsdigita.com)
    @creation-date 12/14/2000
    @cvs-id $Id: element-ae.tcl,v 1.1 2002/07/09 17:35:10 rmello Exp $
} {
    element_id:naturalnum,notnull,optional,permission(read)
}

set package_id [ad_conn package_id]
set master_template [ad_parameter master_template]

if { ! [ad_permission_p $package_id admin] } {
    ad_return_complaint 1 "You don't have permission to administer this package."
    return
}

if { [info exists element_id] } {
    # fetch the element.
    db_0or1row select_element \
	"select
           name,
           description,
           exportable_p,
           datasource_id,
           template_id,
           config_id,
           default_config_id
         from portal_elements
         where element_id = :element_id" -column_array element
} else {
    array set element [list name {} description {} exportable_p {} datasource_id {} template_id {} config_id {} default_config_id {}]
    set element_id [db_nextval acs_object_id_seq]
}

template::multirow create ds datasource_id data_type mime_type name description package_key

# this query needs to identify the package instances mounted beneath it.
db_foreach select_datasources \
    "select
       datasource_id,
       data_type,
       mime_type,
       name,
       description,
       package_key
     from portal_datasources
     order by name" -column_array ds_entry \
{
    template::multirow append ds \
	$ds_entry(datasource_id) \
	$ds_entry(data_type) \
	$ds_entry(mime_type) \
	$ds_entry(name) \
	$ds_entry(description) \
	$ds_entry(package_key)
}

template::multirow create tmpl template_id name description filename resource_dir

db_foreach select_themes \
    "select template_id,name,description,filename,resource_dir
     from portal_templates
     where type = 'theme'
     order by name" -column_array tm \
{
    if { ! [ regexp {^/} $tm(resource_dir)] } {
	set tm(resource_dir) "/packages/portal/www/$tm(resource_dir)"
    }

    template::multirow append tmpl $tm(template_id) $tm(name) $tm(description) $tm(filename) $tm(resource_dir)
}
