# www/element-config-revert.tcl

ad_page_contract {
    Revert element to the datasource's default config.

    @author Ian Baker (ibaker@arsdigita.com)
    @creation-date 1/14/2000
    @cvs-id $Id: element-config-revert.tcl,v 1.1 2002/07/09 17:35:10 rmello Exp $
} {
    element_id:naturalnum,permission(write)
}

set package_id [ad_conn package_id]
set user_id [ad_conn user_id]

ad_require_permission $package_id admin

db_transaction {
   db_1row get_element_info \
	"select
           e.config_id,
           d.default_config_id,
           decode(acs_permission.permission_p(e.config_id, :user_id, 'write'), 't', 1, 'f', 0) as write_p,
           decode(d.configurable_p, 't', 1, 'f', 0) as configurable_p
         from portal_datasources d, portal_elements e
         where e.datasource_id = d.datasource_id and e.element_id = :element_id"

    if { ! $configurable_p } {
	ad_return_complaint 1 "This element doesn't accept a configuration."
	return
    }

    if { ! $write_p } {
	ad_return_complaint 1 "You don't have permission to edit this configuration."
	return
    }

    db_dml revert_element \
       "update portal_elements set config_id = :default_config_id where element_id = :element_id"

}

ns_returnredirect "element-config?element_id=$element_id"
