# www/element-add.tcl
ad_page_contract {
    Add an element to a portal.
} {
    portal_id:naturalnum,notnull,permission(write)
    region:notnull
    element_ids:naturalnum,multiple,notnull
}

set template_id [portal_get_template_id $portal_id]

# this is required to execute the query that initializes the
# datastructures used by portal_region_immutable_p
portal_get_regions $template_id

if { [portal_region_immutable_p $region] && ! [portal_default_p $portal_id] } {
    ad_return_complaint 1 "You don't have permission to edit this region."
    return
}

set master_template [ad_parameter master_template]

# shouldn't it be possible to do this with one query?  Hmmm.
foreach element_id $element_ids {
    # can the user read this element?
    if { ! [ad_permission_p $element_id read] } {
	continue
    }

    db_dml insert_into_map "
      insert into portal_element_map
        (sort_key, portal_id, element_id, region)
      values
        (nvl((select max(sort_key) + 1 from portal_element_map where region = :region), 1), :portal_id, :element_id, :region)"
}

ad_returnredirect "element-layout?[export_url_vars portal_id]"
