# www/element-add.tcl
ad_page_contract {
    Add an element to a portal.
} {
    portal_id:naturalnum,notnull,object_write
    region:notnull
}

set package_id [ad_conn package_id]
set user_id [ad_conn user_id]
set default_portal_id [portal_info default_portal_id]

# this should do a 'preview' type thing, and generate popups for descriptions and stuff.
# (at least, on the JavaScript-heavy version)
# also, a "show me all the elements, even the ones I'm using" button.

set template_id [portal_get_template_id $portal_id]

# this is required to execute the query that initializes the
# datastructures used by portal_region_immutable_p
portal_get_regions $template_id

if { [portal_region_immutable_p $region] && ! [portal_default_p $portal_id]} {
    ad_return_complaint 1 "You don't have permission to edit this region."
    return
}

set master_template [ad_parameter master_template]

template::multirow create element_ids element_id name description 
# do a better job of determining which elements are available, k?
db_foreach select_elements \
    "select element_id, name, description
     from portal_elements
     where element_id in (
         select element_id
         from portal_available_element_map
         where acs_permission.permission_p(element_id, :user_id, 'read') = 't' and portal_id = :default_portal_id
       minus
         select element_id from portal_element_map where portal_id = :portal_id
     )" \
    -column_array element {
    template::multirow append element_ids $element(element_id) $element(name) $element(description)
}

ad_return_template

