# www/element-layout.tcl

ad_page_contract {
    Generate a page with the same layout as the portal, for editing.

    @author Ian Baker (ibaker@arsdigita.com)
    @creation-date 12/6/2000
    @cvs-id $Id: element-layout.tcl,v 1.1 2002/07/09 17:35:10 rmello Exp $
} {
    portal_id:naturalnum,notnull,object_write
}

set package_id [ad_conn package_id]
set user_id [ad_conn user_id]
set master_template [ad_parameter master_template]

# get the portal.
db_1row select_portal {
    select
    p.portal_id,
    p.name,
    t.filename as template,
    t.template_id,
    decode(p.owner_id, null, 1, 0) as default_portal_p,
    decode(acs_permission.permission_p(p.template_id, :user_id, 'read'), 't', 1, 'f', 0) as template_read_p
    from portals p, portal_templates t
    where p.template_id = t.template_id and p.portal_id = :portal_id
} -column_array portal

if { ! $portal(template_read_p) } {
    ad_return_complaint 1 "You don't have permission to read the template for this portal."
    return
}

set context_bar {"Select Elements"}

# fake some elements so that the <list> in the template has something to do.
foreach region [ portal_get_regions $portal(template_id) ] {
    # pass the portal_id along here instead of the element_id.
    lappend fake_element_ids($region) $portal_id
}

set element_list [array get fake_element_ids]
set element_src "/packages/portal/www/place-element"

ad_return_template
