# www/element-move.tcl
ad_page_contract {
    Move an element up or down one space in an area.

    @author Ian Baker (ibaker@arsdigita.com)
    @creation-date 1/22/2000
    @cvs_id $Id: element-move.tcl,v 1.1 2002/07/09 17:35:10 rmello Exp $
} {
    portal_id:naturalnum,notnull,permission(write)
    sort_key:naturalnum,notnull
    region:notnull
    direction:notnull
}

set template_id [portal_get_template_id $portal_id]
portal_get_regions $template_id

# edit immutable areas?  (only with default portals)
if { ! [portal_default_p $portal_id] && [portal_region_immutable_p $region] } {
    ad_return_complaint 1 "You can't edit this area."
}

db_dml move_element \
    "begin
       portal_element.move(portal_id => :portal_id, region => :region, sort_key => :sort_key, direction => :direction);
     end;"

ns_returnredirect "element-layout?portal_id=$portal_id"
