# www/place-element.tcl
ad_page_contract {
    Place elements.

    @author Ian Baker (ibaker@arsdigita.com)
    @creation-date 12/11/2000
    @cvs_id $Id: place-element.tcl,v 1.1 2002/07/09 17:35:10 rmello Exp $
} -properties {
    element_id:onevalue
    region:onevalue
}

set package_id [ad_conn package_id]
set user_id [ad_conn user_id]
set my_url [ad_conn url]

# this is actually the portal_id.  It's passed as element_id to make the template
# designer's job a little easier (one less thing to pass, since it's seldom used anyway)
#  perhaps it should be named something that can represent both values...?
set portal_id $element_id

set default_portal_p [portal_default_p $portal_id]

# can this region be edited?
if { [portal_region_immutable_p $region] } {
    if { $default_portal_p } {
	set immutable_p 0
	set would_be_immutable_p 1
    } else {
	set immutable_p 1
	set would_be_immutable_p 0
    }
} else {
    set immutable_p 0
    set would_be_immutable_p 0
}

# get the elements for this region.
set region_count 0
template::multirow create element_multi element_id name sort_key
db_foreach select_elements_by_region \
    "select e.element_id, e.name, m.sort_key
     from portal_elements e, portal_element_map m
     where
       e.element_id = m.element_id and
       m.portal_id = :portal_id and
       m.region = :region and
       acs_permission.permission_p(e.element_id, :user_id, 'read') = 't'
     order by m.sort_key" \
{
    template::multirow append element_multi $element_id $name $sort_key
    if {$default_portal_p || ![portal_region_immutable_p $region]} {
	incr region_count
    }
}

if { $default_portal_p } {
    db_1row select_all_count \
	"select count(*) as all_count
         from portal_element_map
         where portal_id = :portal_id and acs_permission.permission_p(element_id, :user_id, 'read') = 't'"
} else {
    db_1row select_all_noimm_count \
	"select count(*) as all_count
         from portal_element_map
         where
           portal_id = :portal_id and acs_permission.permission_p(element_id, :user_id, 'read') = 't'
           and region not like 'i%'"
}
