<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="check_tmpl_availability">      
      <querytext>
      select 1 as available_p
         from portal_available_template_map
         where
           portal_id = portal.parent(:default_portal_id) and
           template_id = :template_id
      </querytext>
</fullquery>

 
<fullquery name="determine_portal_existence">      
      <querytext>
      select
           1 as portal_exists_p,
           decode(portal.root_p(portal_id), 't', 1, 'f', 0) as portal_root_p,
           decode(acs_permission.permission_p(portal_id, :user_id, 'write'), 't', 1, 'f', 0) as portal_write_p
         from portals
         where portal_id = :portal_id
      </querytext>
</fullquery>

 
<fullquery name="insert_def_portal">      
      <querytext>
      declare
                   pid portals.portal_id%TYPE;
                 begin
                   pid := portal.new (
                     portal_id => :portal_id,
                     name => :name,
                     template_id => :template_id,
                     package_id => :package_id
                   );
                 end;
      </querytext>
</fullquery>

 
<fullquery name="insert_user_portal">      
      <querytext>
      
		declare
		pid portals.portal_id%TYPE;
		begin
		pid := portal.new ( portal_id => :portal_id,
				    name => :name,
				    owner_id => :user_id,
				    parent_portal_id => :default_portal_id );

		acs_permission.grant_permission ( object_id => pid,
						  grantee_id => :user_id,
						  privilege => 'read' );
		
		acs_permission.grant_permission ( object_id => pid,
						  grantee_id => :user_id,
						  privilege => 'write' );

		acs_permission.grant_permission ( object_id => pid,
						  grantee_id => :user_id,
						  privilege => 'admin' );
		end;
	    
      </querytext>
</fullquery>

 
</queryset>
