# www/render-element.tcl
ad_page_contract {
    Render an element.

    @author Ian Baker (ibaker@arsdigita.com)
    @creation-date 12/11/2000
    @cvs_id $Id: render-element.tcl,v 1.1 2002/07/09 17:35:10 rmello Exp $
} -properties {
    element_id:onevalue
    region:onevalue
}

# get the complete, evaluated element.
# if there's an error, report it.
if { [catch {set element_data [portal_evaluate_element $element_id] } errmsg ] } {
    if { [ad_parameter log_datasource_errors_p] } {
	ns_log Error "portal: $errmsg"
    }
    
    if { [ad_parameter show_datasource_errors_p] } {
	set element(content) "<div class=portal_alert>$errmsg</div>"
	set element(mime_type) "text/html"
    } else {
	return
    }
} else {
    array set element $element_data
}

# consistency is good.
set element(region) $region

# return the appropriate template for that element.
ad_return_template "templates/mime-types/$element(mime_type_noslash)"
